import 'dart:ffi';

import 'array.dart';

/// Delegates method calls to an internally managed [_array].
abstract class DelegatingArray<T extends NativeType> implements Array<T> {
  final Array<T> _array;

  DelegatingArray(this._array);
  @override
  Pointer<T> get ptr => _array.ptr;
  @override
  int get length => _array.length;

  @override
  void delete() {
    _array.delete();
  }

  @override
  String toString() {
    return _array.toString();
  }
}
