import 'dart:ffi';

import 'package:ffi_helper/ffi_helper.dart';
import 'shared_array.dart';

/// References a [SharedArray] without influencing the reference count.
class WeakArray<T extends NativeType> extends ArrayView<T> {
  final SharedArray<T> _shared;
  bool get deleted => _shared.deleted;
  WeakArray(this._shared) : super(_shared);

  /// Converts [this] to a [SharedArray]
  SharedArray<T> toShared() => _shared.newShared();
}
